import com.hp.hpl.jena.ontology.*;
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.util.*;
import com.hp.hpl.jena.query.* ;
import com.hp.hpl.jena.sparql.*;

import com.hp.hpl.jena.reasoner.*;
import com.hp.hpl.jena.reasoner.rulesys.*;

import com.hp.hpl.jena.db.*;

public class MainQueryp  {

    public static final String DB_URL = "jdbc:postgresql://db.slis.indiana.edu:5432/dingyingclass";
    public static final String DB_USER = "your user name";
    public static final String DB_PASSWD = "your password";
    public static final String DB = "PostgreSQL";
    public static final String DB_DRIVER = "org.postgresql.Driver";
 
  public static void main (String args[]) {
 
    try {
        Class.forName("org.postgresql.Driver");
    } catch (ClassNotFoundException e) {
        System.out.println("could not find the JDBC driver");
    }
      
    String filePath = "file:///C:/Jena/Tutorial/expertp/expert.owl";
    IDBConnection con = ontologyDB.connectDB(DB_URL,DB_USER, DB_PASSWD, DB);
    System.out.println(con);
  
    ontologyDB.createDBModelFromFile(con, "expert", filePath);  
    OntModel model = ontologyDB.getModelFromDB(con, "expert");
    
    searchOnto(model);
	}
	
 public static void searchOnto(OntModel model){
     /*Setting up rules*/
     String rule = "[rule1:(?x http://www.owl-ontologies.com/Expert.owl#hasResearch ?y) " +
         "(?y http://www.owl-ontologies.com/Expert.owl#associate ?z) " +
         "->(?x http://www.owl-ontologies.com/Expert.owl#familiar_with ?z)]";
  
     /*query String*/
     String queryString = "PREFIX Expert:<http://www.owl-ontologies.com/Expert.owl#> " +
     "SELECT ?expert ?subject " +
     "WHERE {?expert Expert:familiar_with ?subject} ";
  
     /*set up reasoner*/
     Reasoner reasoner2 = new GenericRuleReasoner(Rule.parseRules(rule));
  
     InfModel inf = ModelFactory.createInfModel(reasoner2, model);
     Query query = QueryFactory.create(queryString);
  
     QueryExecution qe = QueryExecutionFactory.create(query, inf);
     ResultSet results = qe.execSelect();
     
     /*output result*/
     ResultSetFormatter.out(System.out, results, query);
     qe.close();
	}
}
            	
