import java.util.*;

import com.hp.hpl.jena.db.*;
import com.hp.hpl.jena.ontology.*;
import com.hp.hpl.jena.rdf.model.*;

public class ontologyDB {
 
 	/* link database */
	public static IDBConnection connectDB(String DB_URL, String DB_USER, String DB_PASSWD, String DB_NAME) {
    	return new DBConnection(DB_URL, DB_USER, DB_PASSWD, DB_NAME);
	} 
 
	/* Read ontology from filesystem and store it into database */
	public static OntModel createDBModelFromFile(IDBConnection con, String name, String filePath) {
    	ModelMaker maker = ModelFactory.createModelRDBMaker(con);
    	Model base = maker.createModel(name);
    	OntModel newmodel = ModelFactory.createOntologyModel( getModelSpec(maker), base );
   		newmodel.read(filePath);
    	return newmodel;
	}

	/* Get ontology from database */
	public static OntModel getModelFromDB(IDBConnection con, String name) {
    	ModelMaker maker = ModelFactory.createModelRDBMaker(con);
    	Model base = maker.getModel(name);
    	OntModel newmodel = ModelFactory.createOntologyModel( getModelSpec(maker), base);
    	return newmodel;
	}

	public static OntModelSpec getModelSpec(ModelMaker maker) {
    	OntModelSpec spec = new OntModelSpec(OntModelSpec.OWL_MEM);
    	spec.setImportModelMaker(maker);
    	return spec;
	}

}